(defun plaszcz (l)
    (cond ((not (listp l)) (list l))
	  ((null l) '(nil))
	  ((null (cdr l)) (plaszcz (car l)))
	  (t (append (plaszcz (car l)) (plaszcz (cdr l))))
    )
)
	      
(defun liczpoziomy (l &optional (poz 0))
	(cond ((not (listp l)) (list poz))
	      ((null l) (list poz))
	      ((null (cdr l)) (liczpoziomy (car l) (+ poz 1)))
	      (t (append (liczpoziomy (car l) (+ poz 1)) (liczpoziomy (cdr l) poz)))
	)
)

(defun max_poziom (l)
	(max_poziom-rec (liczpoziomy l))
)

(defun max_poziom-rec (l)
	(cond ((null (cdr l)) (car l))
	      (t (max (car l) (max_poziom-rec (cdr l))))
	)
)

(defun drukuj (l)
	(drukuj-rec (plaszcz l) (liczpoziomy l))
)

(defun drukuj-rec (l poziomy)
	(cond ((not (null l))
		(drukuj-spacje (- (car poziomy) 1))
		(prin1 (car l))
		(terpri)
		(drukuj-rec (cdr l) (cdr poziomy))
		)
	      (t (terpri) t))
)

(defun drukuj-spacje (ile)
	(cond ((> ile 0) (princ " ") (drukuj-spacje (- ile 1))))
)

(defun wywazone (l)
	(block nil
		(cond
			((or (atom l) (null (cdr l)))
				(return t)
			)
		)
		(setq l (delete nil l))
		(cond
			((null (caddr l))
				(equal (wysokosc (cadr l)) 0)
			)
			(t
				(and (wywazone (cadr l)) (wywazone (caddr l)) (< (abs (- (wysokosc (cadr l)) (wysokosc (caddr l)))) 2))
			)
		)
	)
)

(defun wysokosc (l)
	(cond
		((null l)
			-1
		)
		((or (atom l) (null (cdr l)))
			0
		)
		(t
			(+ 1 (max (wysokosc (cadr l)) (wysokosc (caddr l))))
		)
	)
)
