(defun kompiluj (wyr &optional (rej 1))
	(let (
		(lista '())
	)
	(cond
		((null wyr)
			(setq lista '())
		)
		((atom wyr)
			(setq lista (list (list 'MOVE rej wyr)))
		)
		((or (equal (car wyr) '-) (equal (car wyr) '+) (equal (car wyr) '/) (equal (car wyr) '*))
			(setq lista (append lista (kompiluj (cadr wyr) rej)))
			(setq lista (append lista (kompiluj (caddr wyr) (+ rej 1))))
			(cond
				((equal (car wyr) '-)
					(setq lista (append lista (list (list 'SUB rej (+ rej 1)))))
				)
				((equal (car wyr) '+)
					(setq lista (append lista (list (list 'ADD rej (+ rej 1)))))
				)
				((equal (car wyr) '*)
					(setq lista (append lista (list (list 'MUL rej (+ rej 1)))))
				)
				((equal (car wyr) '/)
					(setq lista (append lista (list (list 'DIV rej (+ rej 1)))))
				)
			)
		)
		(t
			(setq lista (list (append '(MOVE) (list rej) wyr)))
		)
	)
))

(defun dekompiluj (wyr)
	(let (
		(tmp nil)
	)
	(cond
		((null wyr)
			'()
		)
		(t
			(setq tmp (caar (dekompiluj-rec wyr)))
		)
	)
	(cond
		((null tmp)
			tmp
		)
		((atom tmp)
			(list tmp)
		)
		(t
			tmp
		)
	)
))

(defun dekompiluj-rec (wyr)
	(let (
		(lista '())
		(tmp1 '())
		(tmp2 '())
	)
	(cond
		((null wyr)
			'()
		)
		(t
			(block nil
				(cond
					((equal (caar (last wyr)) 'MOVE)
						(setq lista (cddar (last wyr)))
						(setq wyr (reverse (cdr (reverse wyr))))
						(return)
					)
					((equal (caar (last wyr)) 'DIV)
						(setq lista '(/))
					)
					((equal (caar (last wyr)) 'MUL)
						(setq lista '(*))
					)
					((equal (caar (last wyr)) 'ADD)
						(setq lista '(+))
					)
					(t
						(setq lista '(-))
					)
				)
				(setq wyr (reverse (cdr (reverse wyr))))
				(setq tmp1 (dekompiluj-rec wyr))
				(setq wyr (cadr tmp1))
				(setq tmp2 (dekompiluj-rec wyr))
				(setq wyr (cadr tmp2))
				(setq lista (append lista (car tmp2)))
				(setq lista (append lista (car tmp1)))
				(setq lista (list lista))
			)
		)
	)
	(list lista wyr)
))
