;Jakub Madej B3

(defun czytaj (plik zmienna)
	(let (
		(str (open plik))
	)
	(set zmienna (read str))
	(close str)
))

(defun znajdz (osoba tree)
(cond ((null tree) nil)
        ((and (equal (cadr (assoc 'imie (car tree))) (car osoba))
              (equal (cadr (assoc 'nazwisko (car tree))) (cadr osoba)) )
         (car tree))
        (t (znajdz osoba (cdr tree)))
   )
)

(defun kobieta (osoba tree)
 (cond ((equal (car (assoc 'maz (znajdz osoba tree))) 'maz) t)
       (t nil)
 )
)

(defun rodzice (kto tree)
	(let (
		(starzy nil)
	)
	(cond
		((not (null (cadr (assoc 'matka (znajdz kto tree)))))
			(setq starzy (cdr (assoc 'matka (znajdz kto tree))))
		)
	)
	(cond
		((not (null (cadr (assoc 'ojciec (znajdz kto tree)))))
			(setq starzy (append starzy (cdr (assoc 'ojciec (znajdz kto tree)))))
		)
	)
	starzy
))

(defun dzieci (kto tree)
	(cdr (assoc 'dzieci (znajdz kto tree)))
)

(defun dziadkowie (kto tree)
	(let (
		(lista nil)
	)
	(dolist (i (rodzice kto tree) lista)
		(setq lista (append lista (rodzice i tree)))
	)
))

(defun wnuki (kto tree)
	(let (
		(lista nil)
	)
	(dolist (i (dzieci kto tree) lista)
		(setq lista (append lista (dzieci i tree)))
	)
))

(defun rodzenstwop (os1 os2 tree &optional (przyrodnie nil))
	(cond
		((not przyrodnie)
			(equal (rodzice os1 tree) (rodzice os2 tree))
		)
		(t
			(or (find (car (rodzice os1 tree)) (rodzice os2 tree) :test #'equal) (find (cadr (rodzice os1 tree)) (rodzice os2 tree) :test #'equal))
		)
	)
)

(defun rodzina (tree)
	(cond
		((null tree)
			nil
		)
		(t
			(append (list (append (cdr (assoc 'imie (car tree))) (cdr (assoc 'nazwisko (car tree))))) (rodzina (cdr tree)))
		)
	)
)

(defun potomkowie (os tree &optional (wciecie 0))
	(dolist (i (dzieci os tree) t)
		(dotimes (i wciecie t)
			(princ " ")
		)
		(prin1 (car i))
		(princ " ")
		(prin1 (cadr i))
		(terpri)
		(potomkowie i tree (+ wciecie 1))
	)
)

(defun przodkowie (os tree &optional (wciecie 0))
	(dolist (i (rodzice os tree) t)
		(dotimes (i wciecie t)
			(princ " ")
		)
		(prin1 (car i))
		(princ " ")
		(prin1 (cadr i))
		(terpri)
		(przodkowie i tree (+ wciecie 1))
	)
)

(defun stan (os tree)
	(cond
		((znajdz os tree)
			(cond	
				((kobieta os tree)
					(cond
						((null (cadr (assoc 'maz (znajdz os tree))))
							'panna
						)
						((null (car (reverse (assoc 'maz (znajdz os tree)))))
							'rozwiedziona
						)
						((null (cadr (assoc 'zyje (znajdz (car (reverse (assoc 'maz (znajdz os tree)))) tree))))
							'wdowa
						)
						(t
							'zamezna
						)
					)
				)
				(t
					(cond
						((null (cadr (assoc 'zona (znajdz os tree))))
							'kawaler
						)
						((null (car (reverse (assoc 'zona (znajdz os tree)))))
							'rozwiedziony
						)
						((null (cadr (assoc 'zyje (znajdz (car (reverse (assoc 'zona (znajdz os tree)))) tree))))
							'wdowiec
						)
						(t
							'zonaty
						)
					)
				)
			)
		)
		(t
			nil
		)
	)
)

(defun partner (os tree)
	(cond
		((kobieta os tree)
			(car (reverse (assoc 'maz (znajdz os tree))))
		)
		(t
			(car (reverse (assoc 'zona (znajdz os tree))))
		)
	)
)

(defun zapisz (tree plik)
	(let (
		(str (open plik :direction :output))
	)
	(write tree :stream str)
	(close str)
))

(defun ustaw (kto pole wartosc tree)
	(cond
		((znajdz kto tree)
			(let (
				(tmp nil)
			)
			(setq tmp (remove (assoc pole (znajdz kto tree)) (znajdz kto tree) :test #'equal))
			(setq tree (remove (znajdz kto tree) tree :test #'equal))
			(setq tree (append tree (list (append tmp (list (append (list pole) wartosc))))))
		))
	)
	tree
)

(defun dodaj (imie nazwisko plec malzonek zyje matka ojciec dzieci tree plik)
	(let (
		(tmp nil)
		(par 'maz)
		(npar 'zona)
		(rodz 'ojciec)
	)
	(cond
		((equal plec 'k)
			(setq par 'zona)
			(setq rodz 'matka)
			(setq npar 'maz)
		)
	)
	(setq tmp (list (list 'imie imie) (list 'nazwisko nazwisko) (list 'zyje zyje) (list 'matka matka) (list 'ojciec ojciec)))
	(setq tmp (append tmp (list (list npar malzonek))))
	(setq tree (ustaw malzonek par (append (remove nil (cdr (assoc par (znajdz malzonek tree))) :test #'equal) (list (list imie nazwisko)) ) tree))
	(dolist (i dzieci t)
		(setq tree (ustaw i rodz (list (list imie nazwisko)) tree))
	)
	(setq tmp (append tmp (list (append '(dzieci) dzieci))))
	(setq tree (append tree (list tmp)))
	(setq tree (ustaw matka 'dzieci (append (dzieci matka tree) (list (list imie nazwisko))) tree))
	(setq tree (ustaw ojciec 'dzieci (append (dzieci ojciec tree) (list (list imie nazwisko))) tree))
	(zapisz tree plik)
))

(defun usun (kogo tree plik)
	(let (
		(par 'maz)
		(rodz 'ojciec)
	)
	(dolist (i (rodzice kogo tree) t)
		(cond
			((remove kogo (dzieci i tree) :test #'equal)
				(setq tree (ustaw i 'dzieci (remove kogo (dzieci i tree) :test #'equal) tree))
			)
			(t
				(setq tree (ustaw i 'dzieci '(nil) tree))
			)
		)
	)
	(cond
		((kobieta kogo tree)
			(setq par 'zona)
			(setq rodz 'matka)
		)
	)
	(cond
		((remove kogo (cdr (assoc par (znajdz (partner kogo tree) tree))) :test #'equal)
			(setq tree (ustaw (partner kogo tree) par (remove kogo (cdr (assoc par (znajdz (partner kogo tree) tree))) :test #'equal) tree))
		)
		(t
			(setq tree (ustaw (partner kogo tree) par '(nil) tree))
		)
	)
	(dolist (i (dzieci kogo tree) t)
		(setq tree (ustaw i rodz '(nil) tree))
	)
	(setq tree (remove (znajdz kogo tree) tree :test #'equal))
	(zapisz tree plik)
))

(defun krewni (&optional (a1 nil) (a2 nil) (a3 nil) (a4 nil) (a5 nil) (a6 nil))
	"matka babci"
)

(defun pokrew (&optional (a1 nil) (a2 nil) (a3 nil) (a4 nil) (a5 nil) (a6 nil))
)
